三.获取SolidWorks文件中的网格信息
SolidWorks插件-将SolidWorks文件转换为gltf格式
- 一.SolidWorks文件转换为glTF格式
- 二.搭建一个Taskpane的SolidWorks插件
- 三.获取SolidWorks文件中的网格信息
- 四.获取SolidWorks中的材质信息
- 五.转换为glTF格式
- 六.装配体和多实体格式的转换
- 去Github查看代码或下载插件安装包
1.关于格式转换
SolidWorks作为一个参数化设计软件,其格式信息中肯定包含了许多特征信息。但gltf作为一个多数情况下只用来浏览的格式,我们需要的只是几何,材质,动画等信息。其实我们能从SolidWorks中解析出来的出了特征以外大概也就是那么多信息。
2.网格(Mesh)
- 从SoidWorks实体中提取出我们需要的网格信息,然后将其转换到gltf的Mesh节点。
2.1 提取实体信息
- 假设我们拿到了一个*.sldprt文件。在转换时我们可以通过打开此文件,或者获取sldworks中的活动文档来获取到一个ModelDoc2接口。
ModelDoc2 swModel = swApp.ActiveDoc;
- SolidWorks作为一个多是体建模软件,所以一个零件中可能存在多个实体(Body,注意与Entity的区别都翻译为实体)。如果有多个实体,我们就要获取全部实体。
private SWglTFModel ConvertPartToglTF(ModelDoc2 swModel)
{
SWglTFModel Model = new SWglTFModel();
var MaterialValue = ((PartDoc)swModel).MaterialPropertyValues;
if (MaterialValue != null)
{
Model.PartMaterialValue = MaterialValue;
}
object[] bodys = ((PartDoc)swModel).GetBodies((int)swBodyType_e.swAllBodies);
foreach (Body2 swBody in bodys)
{
Model.BodyList.Add(GetglTFBodyModel(swBody));
}
return Model;
}
- 获取每个实体中的网格材质
private Model.BodyglTFModel GetglTFBodyModel(Body2 swBody)
{
if (swBody == null)
{
return null;
}
BodyglTFModel BodyModel = new BodyglTFModel();
try
{
var BodyMaterial = (double[])swBody.MaterialPropertyValues2;
if (BodyMaterial != null)
{
BodyModel.BodyMaterialValue = BodyMaterial;
}
#region 网格化
Tessellation swTessellation = swBody.GetTessellation(null);
if (swTessellation != null)
{
swTessellation.NeedFaceFacetMap = true;
swTessellation.NeedVertexParams = true;
swTessellation.NeedVertexNormal = true;
swTessellation.ImprovedQuality = true;
// How to handle matches across common edges
swTessellation.MatchType = (int)swTesselationMatchType_e.swTesselationMatchFacetTopology;
// Do it
bool bResult = swTessellation.Tessellate();
}
else
{
return null;
}
#endregion
Face2 swFace = (Face2)swBody.GetFirstFace();
while (swFace != null)
{
Model.FaceglTFModel FaceModel = new FaceglTFModel();
var FaceMaterial = swFace.MaterialPropertyValues;
if (FaceMaterial != null)
{
FaceModel.FaceMaterialValue = FaceMaterial;
}
#region 面的三角化
int[] aFacetIds = (int[])swTessellation.GetFaceFacets(swFace);
int iNumFacetIds = aFacetIds.Length;
for (int iFacetIdIdx = 0; iFacetIdIdx < iNumFacetIds; iFacetIdIdx++)
{
int[] aFinIds = (int[])swTessellation.GetFacetFins(aFacetIds[iFacetIdIdx]);
// There should always be three fins per facet
FaceVertexModel model = new FaceVertexModel();
List points = new List();
for (int iFinIdx = 0; iFinIdx < 3; iFinIdx++)
{
int[] aVertexIds = (int[])swTessellation.GetFinVertices(aFinIds[iFinIdx]);
// Should always be two vertices per fin
double[] aVertexCoords1 = (double[])swTessellation.GetVertexPoint(aVertexIds[0]);
double[] aVertexCoords2 = (double[])swTessellation.GetVertexPoint(aVertexIds[1]);
var v1 = new VERTEX(Convert.ToSingle(aVertexCoords1[0]),
Convert.ToSingle(aVertexCoords1[1]),
Convert.ToSingle(aVertexCoords1[2]));
var v2 = new VERTEX(Convert.ToSingle(aVertexCoords2[0]),
Convert.ToSingle(aVertexCoords2[1]),
Convert.ToSingle(aVertexCoords2[2]));
bool isContain = false;
foreach (var item in points)
{
if ((Math.Abs(item[0] - aVertexCoords1[0]) + Math.Abs(item[1] - aVertexCoords1[1]) + Math.Abs(item[2] - aVertexCoords1[2])) < 0.00001)
{
isContain = true;
}
}
if (!isContain)
{
points.Add(aVertexCoords1);
}
isContain = false;
foreach (var item in points)
{
if ((Math.Abs(item[0] - aVertexCoords2[0]) + Math.Abs(item[1] - aVertexCoords2[1]) + Math.Abs(item[2] - aVertexCoords2[2])) < 0.00001)
{
isContain = true;
}
}
if (!isContain)
{
points.Add(aVertexCoords2);
}
}
if (points.Count == 3)
{
model.a = new VERTEX(Convert.ToSingle(points[0][0]),
Convert.ToSingle(points[0][1]),
Convert.ToSingle(points[0][2]));
model.b = new VERTEX(Convert.ToSingle(points[1][0]),
Convert.ToSingle(points[1][1]),
Convert.ToSingle(points[1][2]));
model.c = new VERTEX(Convert.ToSingle(points[2][0]),
Convert.ToSingle(points[2][1]),
Convert.ToSingle(points[2][2]));
FaceModel.FaceTri.Add(model);
}
}
if (FaceModel.FaceTri.Count > 0)
{
BodyModel.FaceList.Add(FaceModel);
}
swFace = (Face2)swFace.GetNextFace();
#endregion
}
}
catch (Exception ex)
{
MessageBox.Show(ex.Tostring())
}
return BodyModel;
}
2.3 关于 SWglTFModel BodyglTFModel FaceglTFModel 和 FaceVertexModel
为了完成整个装欢过程,我将SolidWorks中的信息转换到SWglTFModel类中,SWglTFModel中描述了一个模型所有的材质信息,他具有的所有实体,以及这个实体的材质和实体所有的所有面,每一个面又包含了组成他的、
所有顶点信息(FaceVertexModel)和材质。在完成了ModelDoc2向SWglTFModel这个数据结构的转换后,再由这个类完成向gltf的转换,整个转换过程类似一个适配器模式。
- 下一节将介绍这几个类。